<?php

namespace app\common\validate;

use think\Validate;
/**
 * ============================================================================
 * 
 * ============================================================================
 * 版权所有 2014-2028 浙江惠利玛产业互联网有限公司，并保留所有权利。
 * 网站地址: https://www.valimart.net/
 * ----------------------------------------------------------------------------
 * 
 * ============================================================================
 * 验证器
 */
class  Buy extends Validate
{
    protected $rule = [
        'address_realname'=>'require',
        'address_detail'=>'require',
    ];
    protected $message = [
        'address_realname.require'=>'真实姓名必填',
        'address_detail.require'=>'地址为必填',
    ];
    protected $scene = [
        'add_addr' => ['address_realname', 'address_detail'],
    ];

}