<?php

namespace app\common\validate;


use think\Validate;
/**
 * ============================================================================
 * 
 * ============================================================================
 * 版权所有 2014-2028 浙江惠利玛产业互联网有限公司，并保留所有权利。
 * 网站地址: https://www.valimart.net/
 * ----------------------------------------------------------------------------
 * 
 * ============================================================================
 * 验证器
 */
class  Document extends Validate
{
    protected $rule = [
        'document_title'=>'require',
        'document_content'=>'require'
    ];
    protected $message = [
        'document_title.require'=>'文章标题不能为空',
        'document_content.require'=>'文章内容不能为空'
    ];
    protected $scene = [
        'edit' => ['document_title', 'document_content'],
    ];
}