<?php

namespace app\common\validate;


use think\Validate;
/**
 * ============================================================================
 * 
 * ============================================================================
 * 版权所有 2014-2028 浙江惠利玛产业互联网有限公司，并保留所有权利。
 * 网站地址: https://www.valimart.net/
 * ----------------------------------------------------------------------------
 * 
 * ============================================================================
 * 验证器
 */
class  Fleaclass extends Validate
{
    protected $rule = [
        'fleaclass_name'=>'require',
        'fleaclass_sort'=>'require|number'
    ];
    protected $message = [
        'fleaclass_name.require'=>'分类名称不能为空',
        'fleaclass_sort.require'=>'分类排序仅能为数字',
        'fleaclass_sort.number'=>'分类排序仅能为数字'
    ];
    protected $scene = [
        'goods_class_add' => ['fleaclass_name', 'fleaclass_sort'],
        'goods_class_edit' => ['fleaclass_name', 'fleaclass_sort'],
    ];
}