<?php
namespace app\common\validate;
use think\Validate;
/**
 * ============================================================================
 * 
 * ============================================================================
 * 版权所有 2014-2028 浙江惠利玛产业互联网有限公司，并保留所有权利。
 * 网站地址: https://www.valimart.net/
 * ----------------------------------------------------------------------------
 * 
 * ============================================================================
 * 验证器
 */
class  Memberbank extends Validate
{
    protected $rule = [
        'memberbank_type'=>'require',
        'memberbank_truename'=>'require',
        'memberbank_no'=>'require',

    ];
    protected $message = [
        'memberbank_type.require'=>'账户类型不能为空',
        'memberbank_truename.require'=>'开户名不能为空',
        'memberbank_no.require'=>'账号不能为空',

    ];
    protected $scene = [
        'add' => ['memberbank_type', 'memberbank_truename', 'memberbank_no'],
        'edit' => ['memberbank_type', 'memberbank_truename', 'memberbank_no'],
    ];


}