<?php

namespace app\common\validate;


use think\Validate;
/**
 * ============================================================================
 * 
 * ============================================================================
 * 版权所有 2014-2028 浙江惠利玛产业互联网有限公司，并保留所有权利。
 * 网站地址: https://www.valimart.net/
 * ----------------------------------------------------------------------------
 * 
 * ============================================================================
 * 验证器
 */
class  Selleralbum extends Validate
{
    protected $rule = [
        'aclass_name'=>'require',
        'aclass_des'=>'require',
        'aclass_sort'=>'require'
    ];
    protected $message = [
        'aclass_name.require'=>'相册名称必填',
        'aclass_des.require'=>'相册描述必填',
        'aclass_sort.require'=>'相册排序必填'
    ];
    protected $scene = [
        'album_add_save' => ['aclass_name','aclass_des','aclass_sort'],
        'album_edit_save' => ['aclass_name','aclass_des','aclass_sort']
    ];
}