<?php

namespace app\common\validate;


use think\Validate;
/**
 * ============================================================================
 * 
 * ============================================================================
 * 版权所有 2014-2028 浙江惠利玛产业互联网有限公司，并保留所有权利。
 * 网站地址: https://www.valimart.net/
 * ----------------------------------------------------------------------------
 * 
 * ============================================================================
 * 验证器
 */
class  Sellerdeliverset extends Validate
{
    protected $rule = [
        'seller_name'=>'require',
        'daddress_detail'=>'require',
        'daddress_telphone'=>'require',
        'store_printexplain'=>'require|length:1,200'
    ];
    protected $message = [
        'seller_name.require'=>'联系人必填',
        'daddress_detail.require'=>'地址必填',
        'daddress_telphone.require'=>'电话必填',
        'store_printexplain.require'=>'说明不能为空|长度在1-200之间',
        'store_printexplain.length'=>'说明不能为空|长度在1-200之间'
    ];
    protected $scene = [
        'daddress_add' => ['seller_name', 'daddress_detail', 'daddress_telphone'],
        'print_set' => ['store_printexplain'],
    ];
}