<?php

namespace app\common\validate;


use think\Validate;
/**
 * ============================================================================
 * 
 * ============================================================================
 * 版权所有 2014-2028 浙江惠利玛产业互联网有限公司，并保留所有权利。
 * 网站地址: https://www.valimart.net/
 * ----------------------------------------------------------------------------
 * 
 * ============================================================================
 * 验证器
 */
class  Consulting extends Validate
{
    protected $rule = array(
       'consulttype_name'=>'require',
       'consulttype_sort'=>'require|number',
    );
    protected $message = array(
       'consulttype_name.require'=>'请填写咨询类型名称',
       'consulttype_sort.require'=>'请正确填写咨询类型排序',
       'consulttype_sort.number'=>'请正确填写咨询类型排序',
    );
    protected $scene = [
        'type_add' => ['consulttype_name', 'sort'],
        'type_edit' => ['consulttype_name', 'sort'],
    ];
}