<?php

namespace app\common\validate;


use think\Validate;
/**
 * ============================================================================
 * 
 * ============================================================================
 * 版权所有 2014-2028 浙江惠利玛产业互联网有限公司，并保留所有权利。
 * 网站地址: https://www.valimart.net/
 * ----------------------------------------------------------------------------
 * 
 * ============================================================================
 * 验证器
 */
class  Navigation extends Validate
{
    protected $rule = [
        'nav_sort'=>'number',
        'nav_title'=>'require',
    ];
    protected $message = [
        'nav_sort.number'=>'排序只能为数字',
        'nav_title.require'=>'标题不能为空',
    ];
    protected $scene = [
        'add' => ['nav_sort', 'nav_title'],
        'edit' => ['nav_sort', 'nav_title'],
    ];
}