<?php

namespace app\common\validate;


use think\Validate;
/**
 * ============================================================================
 * 
 * ============================================================================
 * 版权所有 2014-2028 浙江惠利玛产业互联网有限公司，并保留所有权利。
 * 网站地址: https://www.valimart.net/
 * ----------------------------------------------------------------------------
 * 
 * ============================================================================
 * 验证器
 */
class  Sellerplate extends Validate
{
    protected $rule = [
        'storeplate_name'=>'require',
        'storeplate_content'=>'require',
    ];
    protected $message = [
        'storeplate_name.require'=>'请填写版式名称',
        'storeplate_content.require'=>'请填写版式内容',
    ];
    protected $scene = [
        'plate_add' => ['storeplate_name', 'storeplate_content'],
        'plate_edit' => ['storeplate_name', 'storeplate_content'],
    ];
}